{
=============================================================================
| THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"  |
| AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE    |
| IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   |
| ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR  |
| ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL       |
| DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR   |
| SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER   |
| CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT           |
| LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY    |
| OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH  |
| DAMAGE.                                                                      |
=============================================================================
   Author:  D.J.C. Blijker.
   Date:    27-4-2003
   version: 1.0
   e-mail:  c.blijker@wxs.nl
-----------------------------------------------------------------------------
  This program serves just as a very simple example of an implementation of
  a blocking TCP-client.
  On startup this program tries to connect to an TCP-server at localhost
  on port 3003. If the connection succeeds you can send something to the
  server. After sending this program tries to receive some data for 5 seconds.
=============================================================================
}
unit BlockingClient_Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,

  HxDataExchange, HxTcpIpcUdp, StdCtrls;

type
  TForm5 = class(TForm)
    mmo: TMemo;
    btnSend: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnSendClick(Sender: TObject);
  private
    { Private declarations }
    de: THxDataExchange;
    tcpBlkClient: THxTcpBlockClient;
    procedure ShowClosedConnection;
    procedure ShowNotification(sMess: string);
  public
    { Public declarations }
  end;

var
  Form5: TForm5;

implementation

{$R *.DFM}

procedure TForm5.FormCreate(Sender: TObject);
begin
  de := THxDataExchange.Create;

  tcpBlkClient := THxTcpBlockClient.Create;
  tcpBlkClient.Port := '3003';
  tcpBlkClient.ServerAddress := '127.0.0.1';
  tcpBlkClient.OnConnectionClosed := ShowClosedConnection;
  tcpBlkClient.OnNotify := ShowNotification;
  if tcpBlkClient.Connect then
    mmo.Lines.Add('Connected')
  else
    mmo.Lines.Add('Not connected');
end;

procedure TForm5.ShowClosedConnection;
begin
  mmo.Lines.Add('Connection closed..');
end;

procedure TForm5.FormDestroy(Sender: TObject);
begin
  de.Free;
  tcpBlkClient.Free;
end;

procedure TForm5.ShowNotification( sMess: string );
begin
  mmo.Lines.Add( sMess );
end;

procedure TForm5.btnSendClick(Sender: TObject);
var
  ptr: pointer;
  iSize: integer;
  s: string;
begin
  if tcpBlkClient.Connected then
  begin
    if not( tcpBlkClient.SendString('Dag dag..'))then  // Dutch for bye-bye ;-)
    begin
      mmo.Lines.Add('Can''t send (anymore)');
      exit;
    end;
    if tcpBlkClient.ReceiveData( ptr, iSize, 5 )then
    begin
      de.ReadString( ptr, s );
      mmo.Lines.Add( s );
    end
    else
      mmo.Lines.Add('Didn''t receive anything within 5 seconds..');
  end
  else
    mmo.Lines.Add('Not connected');
end;

end.
